#include <ctype.h> /* for useful char functions */
#include <stdio.h> /* for EOF */

#include "getop.h" /* To get the shared constant N */
#include "getch.h" /* We use getch() and ungetch() */

int j = 0; /* external variable shared by functions */

/* getop: get next operator or numeric operand */
char getop(char s[])
{
  int c, i;

  /* Skip whitespace */
  while (((s[0] = c = getch()) == ' ') || (c == '\t')) {
    ; /* do nothing */
  }

  /* Not a number.  Return operator. */
  s[1] = '\0';
  if (!isdigit(c) && c != '.') {
    return c;
  }

  /* Gather the parts of the number */
  
  i = 0;
  if (isdigit(c)) { /* Collect integer part */       
    while (isdigit(s[++i] = c = getch())) {
      ;
    }
  }
  
  if (c == '.') { /* Collect fractional part */            
    while (isdigit(s[++i] = c = getch())) {
      ;
    }
  }
  s[i] = '\0';

  /* push the last character we read back on the input, if such a char
     exists exists */
  if (c != EOF) { 
    ungetch(c);
  }
  
  return NUMBER;
}
